=== debian/changelog ===
intrusive-shared-ptr (1.4-2) unstable; urgency=medium

  * Upload to unstable

 -- Dylan Aïssi <daissi@debian.org>  Sat, 25 May 2024 22:13:34 +0200

intrusive-shared-ptr (1.4-1) experimental; urgency=medium

  * Initial Debian release.

 -- Dylan Aïssi <daissi@debian.org>  Thu, 23 May 2024 21:39:55 +0200
