=== debian/control ===
Source: intrusive-shared-ptr
Section: libdevel
Priority: optional
Maintainer: Dylan Aïssi <daissi@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://github.com/gershnik/intrusive_shared_ptr
Vcs-Browser: https://salsa.debian.org/debian/isptr
Vcs-Git: https://salsa.debian.org/debian/isptr.git

Package: libisptr-dev
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: another implementation of an intrusive reference counting smart
 isptr is yet another implementation of an intrusive reference counting smart
 pointer, highly configurable reference counted base class and adapters.
