=== debian/changelog ===
intrusive-shared-ptr (1.5-1) unstable; urgency=medium

  * New upstream version 1.5
  * Add doctest-dev in Build-Deps
  * Add patch to use system doctest for building unit tests
  * Update debian/copyright

 -- Dylan Aïssi <daissi@debian.org>  Sun, 13 Oct 2024 14:54:17 +0200
