=== debian/control ===
--- 
+++ 
@@ -3,7 +3,8 @@
 Priority: optional
 Maintainer: Dylan Aïssi <daissi@debian.org>
 Build-Depends: debhelper-compat (= 13),
-               cmake
+               cmake,
+               doctest-dev
 Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://github.com/gershnik/intrusive_shared_ptr
