## intrusive-shared-ptr 1.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -34,6 +34,7 @@
 
 set(PUBLIC_HEADERS 
     ${SRCDIR}/inc/intrusive_shared_ptr/intrusive_shared_ptr.h
+    ${SRCDIR}/inc/intrusive_shared_ptr/common.h
     ${SRCDIR}/inc/intrusive_shared_ptr/apple_cf_ptr.h
     ${SRCDIR}/inc/intrusive_shared_ptr/com_ptr.h
     ${SRCDIR}/inc/intrusive_shared_ptr/python_ptr.h
