=== test/CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,7 @@
 FetchContent_Declare(doctest
     URL  https://raw.githubusercontent.com/doctest/doctest/v2.4.11/doctest/doctest.h
     DOWNLOAD_NO_EXTRACT TRUE
+    SOURCE_DIR downloaded/doctest
 )
 
 FetchContent_MakeAvailable(doctest)
@@ -42,7 +43,7 @@
 
         set(TEST_TARGET_NAME test-${TEST_SUFFIX}-${TEST_VARIANT})
 
-        add_executable(${TEST_TARGET_NAME})
+        add_executable(${TEST_TARGET_NAME} EXCLUDE_FROM_ALL)
 
         set_target_properties(${TEST_TARGET_NAME} PROPERTIES
             CXX_STANDARD ${CXX_STANDARD_${TEST_SUFFIX}}
@@ -59,7 +60,7 @@
         endif()
 
         target_include_directories(${TEST_TARGET_NAME} PRIVATE
-            ${doctest_SOURCE_DIR}
+            ${CMAKE_CURRENT_BINARY_DIR}/downloaded
         )
 
         if (ISPTR_ENABLE_PYTHON)
@@ -117,6 +118,6 @@
 
 endforeach()
 
-add_custom_target(run-test 
+add_custom_target(run-test
     ${TEST_COMMAND}
 )
