=== debian/changelog ===
intrusive-shared-ptr (1.6-1) unstable; urgency=medium

  * New upstream version 1.6
  * Drop patch included in upstream release
  * Drop manual installation of common.h, fixed upstream
  * Mark libisptr-dev as 'Multi-Arch: same'
  * Add debian/salsa-ci.yml

 -- Dylan Aïssi <daissi@debian.org>  Wed, 19 Feb 2025 10:21:24 +0100
