=== debian/control ===
--- 
+++ 
@@ -13,6 +13,7 @@
 
 Package: libisptr-dev
 Architecture: any
+Multi-Arch: same
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Description: another implementation of an intrusive reference counting smart
