=== debian/watch ===
version=4
https://github.com/gershnik/intrusive_shared_ptr/tags .*/v?(\d.*)@ARCHIVE_EXT@
